/* Copyright 2017, Michele Santullo
 * This file is part of "kamokan".
 *
 * "kamokan" is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * "kamokan" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with "kamokan".  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "general_pastie_response.hpp"

namespace kamokan {
	class EditResponse : public GeneralPastieResponse {
	public:
		EditResponse (
			const Kakoune::SafePtr<SettingsBag>& parSettings,
			std::ostream* parStreamOut,
			const Kakoune::SafePtr<cgi::Env>& parCgiEnv
		);

	protected:
		virtual boost::string_view page_basename() const override {
			return boost::string_view("edit");
		}

	private:
		virtual void on_general_mustache_prepare (std::string&& parPastie, mstch::map& parContext) override;
		virtual tawashi::HttpHeader on_general_pastie_process() override;
		virtual bool is_submit_page() const override { return true; }
	};
} //namespace kamokan
